package com.dbxml.db.admin.nodes;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: UsersNode.java,v 1.4 2004/07/29 12:26:47 bradford Exp $
 */

import com.dbxml.db.client.CollectionClient;
import com.dbxml.db.common.security.AccessManagerClient;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 * UsersNode
 */

public final class UsersNode extends AdminNode implements HasCollection, HasChildren {
   private static final AdminNode[] EmptyAdminNodes = new AdminNode[0];
   private static final Icon UsersIcon = new ImageIcon(CollectionNode.class.getResource("users_mini.gif"));

   public static final int ACTION_ADD = 0;

   private static final MenuItem[] Menu = new MenuItem[]{
      new MenuItem(ACTION_ADD, "Add User"),
   };

   private CollectionClient col;

   public UsersNode(AdminNode parentNode, CollectionClient col) {
      super(parentNode);

      this.col = col;
   }

   public String getLabel() {
      return "Database Users";
   }

   public String getMenuTitle() {
      return "Users";
   }

   public Icon getIcon() {
      return UsersIcon;
   }

   public CollectionClient getCollection() {
      return col;
   }

   public AdminNode[] getChildren() {
      try {
         AccessManagerClient manager = new AccessManagerClient(col.getClient());
         String[] users = manager.listUsers();
         AdminNode[] list = new AdminNode[users.length];
         for ( int i = 0; i < users.length; i++ )
            list[i] = new UserNode(this, col, users[i]);

         return list;
      }
      catch ( Exception e ) {
         return EmptyAdminNodes;
      }
   }

   public MenuItem[] getMenu() {
      return Menu;
   }
}
